#include "dxfout.h"

DXF3DOut::DXF3DOut(const char *fname) {
	f = fopen(fname, "w");

	fputs(
		"999\n"
		"DXF created from Aeris\n"
		"0\n"
		"SECTION\n"
		"2\n"
		"HEADER\n"
		"9\n"
		"$ACADVER\n"
		"1\n"
		"AC1006\n"
		"9\n"
		"$INSBASE\n"
		"10\n"
		"0.0\n"
		"20\n"
		"0.0\n"
		"30\n"
		"0.0\n"
		"9\n"
		"$EXTMIN\n"
		"10\n"
		"0.0\n"
		"20\n"
		"0.0\n"
		"9\n"
		"$EXTMAX\n"
		"10\n"
		"1000.0\n"
		"20\n"
		"1000.0\n"
		"0\n"
		"ENDSEC\n", f);

	fputs(
		"0\n"
		"SECTION\n"
		"2\n"
		"TABLES\n"
		"0\n"
		"TABLE\n"
		"2\n"
		"LTYPE\n"
		"70\n"
		"1\n"
		"0\n"
		"LTYPE\n"
		"2\n"
		"CONTINUOUS\n"
		"70\n"
		"64\n"
		"3\n"
		"Solid line\n"
		"72\n"
		"65\n"
		"73\n"
		"0\n"
		"40\n"
		"0.000000\n"
		"0\n"
		"ENDTAB\n", f);

	fputs(
		"0\n"
		"TABLE\n"
		"2\n"
		"LAYER\n"
		"70\n"
		"6\n"
		"0\n"
		"LAYER\n"
		"2\n"
		"1\n"
		"70\n"
		"64\n"
		"62\n"
		"7\n"
		"6\n"
		"CONTINUOUS\n"
		"0\n"
		"LAYER\n"
		"2\n"
		"2\n"
		"70\n"
		"64\n"
		"62\n"
		"7\n"
		"6\n"
		"CONTINUOUS\n"
		"0\n"
		"ENDTAB\n"
		"0\n"
		"TABLE\n"
		"2\n"
		"STYLE\n"
		"70\n"
		"0\n"
		"0\n"
		"ENDTAB\n"
		"0\n"
		"ENDSEC\n", f);

	fputs(
		"0\n"
		"SECTION\n"
		"2\n"
		"BLOCKS\n"
		"0\n"
		"ENDSEC\n", f);

	fputs(
		"0\n"
		"SECTION\n"
		"2\n"
		"ENTITIES\n", f);
}

DXF3DOut::~DXF3DOut() {
	fputs(
		"0\n"
		"ENDSEC\n", f);

	fputs(
		"0\n"
		"EOF\n", f);

	fclose(f);
}

void DXF3DOut::writeTriangle(const float *pts) {
	fprintf(f,
		"0\n"
		"3DFACE\n"
		"8\n"
		"1\n"
		"62\n"
		"3\n"
		"10\n"		"%f\n"
		"20\n"		"%f\n"
		"30\n"		"%f\n"
		"11\n"		"%f\n"
		"21\n"		"%f\n"
		"31\n"		"%f\n"
		"12\n"		"%f\n"
		"22\n"		"%f\n"
		"32\n"		"%f\n"
		"13\n"		"%f\n"
		"23\n"		"%f\n"
		"33\n"		"%f\n"
		, pts[0]
		, pts[1]
		, pts[2]
		, pts[3]
		, pts[4]
		, pts[5]
		, pts[6]
		, pts[7]
		, pts[8]
		, pts[6]
		, pts[7]
		, pts[8]);
}

void DXF3DOut::writeQuad(const float *pts) {
	fprintf(f,
		"0\n"
		"3DFACE\n"
		"8\n"
		"1\n"
		"62\n"
		"3\n"
		"10\n"		"%f\n"
		"20\n"		"%f\n"
		"30\n"		"%f\n"
		"11\n"		"%f\n"
		"21\n"		"%f\n"
		"31\n"		"%f\n"
		"12\n"		"%f\n"
		"22\n"		"%f\n"
		"32\n"		"%f\n"
		"13\n"		"%f\n"
		"23\n"		"%f\n"
		"33\n"		"%f\n"
		, pts[0]
		, pts[1]
		, pts[2]
		, pts[3]
		, pts[4]
		, pts[5]
		, pts[6]
		, pts[7]
		, pts[8]
		, pts[9]
		, pts[10]
		, pts[11]);
}
